/* Fitxer: Alumne07.java
   Descripci: Classe derivada de la classe abstracta Persona (fitxer Persona07.java)
               Continuem amb un nombre elevat de constructors per exemplificar situacions.
   Autor: Isidre Guix
*/

class Alumne extends Persona
{
   private char nivell = '?';
   /** Valors vlids: 
       B = Batxillerat
       M = Cicle Fromatiu Mitj
       S = Cicle Formatiu Superior
       ? = Desconegut
   */
   
   public Alumne () {}
   
   public Alumne (String sDni, String sNom, int nEdat, char cNivell)
   {
      super (sDni, sNom, nEdat);
      nivell = validarNivell (cNivell);
   }
   
   public Alumne (Persona p, char cNivell)   // (1)
   {
      super (p);
      nivell = validarNivell (cNivell);
   }
   
   public Alumne (Persona p)  // (2)  
   {
      this (p, '?');
   }
   
   public Alumne (String sDni, String sNom, int nEdat)
   {
      this (sDni, sNom, nEdat, '?');
   }

   public Alumne (Alumne a)
   {
      this (a.dni, a.nom, a.edat, a.nivell);
   }

   public Alumne clonar ()
   {
      return new Alumne (this);
   }
   
   public void setNivell (char nouNivell)
   {
      nivell = validarNivell (nouNivell);
   }
   
   private char validarNivell (char nivell)
   /** Valida el "nivell" passat per parmetre, de manera que retorna el valor
       vlid i en majscula. Si no era vlid, retorna '?'. */
   {
      nivell = Character.toUpperCase(nivell);
      if (nivell!='B' && nivell!='S' && nivell!='M') nivell='?';
      return nivell;
   }
   
   public char getNivell () { return nivell; }
   
   public void visualitzar ()
   {
      super.visualitzar ();
      System.out.println("Nivell........:" + nivell);
   }
   
   public String toString()
   {
      String s = "Dni: " + dni + " - Nom: " + nom + " - Edat: " + edat + " - Nivell: "; 
      switch (nivell)
      {
         case 'B': s = s + "Batxillerat"; break;
         case 'M': s = s + "Cicle F. Mitj"; break;
         case 'S': s = s + "Cicle F. Superior"; break;
         default : s = s + "???"; break;
      }
      return s;
   }
   
   public static void main(String args[])
   {
      Alumne t[] = new Alumne[6];
      t[0] = new Alumne();
      t[1] = new Alumne("00000000","Pepe Gotera",33,'b');
      t[2] = new Alumne("00000000","Pepe Gotera",33);
      t[3] = new Alumne((Persona)t[1],'m');  // Exemple de crida al constructor (1)
      t[4] = new Alumne((Persona)t[2],'s');  // Exemple de crida al constructor (2)
      t[5] = new Alumne(t[3]);
      
      for (int i=0; i<t.length; i++) System.out.println(t[i]);
   }
}